#include "mgc4lz.h"

#pragma once

// CM4lz R}h ^[Qbg
//
//  mgc4lz.dll [hNXł
//	Ver4.1600a
//	
class CM4lz : public CObject
{
public:
	CM4lz();
	virtual ~CM4lz();
	
	void LoadDll();
	void UnloadDll();
	int	 AreYouReady();
	int  GetFileVersion(	LPCTSTR lpszFileName,
							DWORD* lpdwMajor,
							DWORD* lpdwMinor,
							DWORD* lpdwRevision,
							DWORD* lpdwBild);

	//
	////  ֐`
	//
	typedef int		(CALLBACK* LPMLZINITIALIZE) (LPMLZ_INI_PARAMETERS lpParameters);
	typedef UINT	(CALLBACK* LPMLZSTART) (HWND hWnd, LPMLZ_STR_PARAMETERS lpParameters);
	typedef int		(CALLBACK* LPMLZSTOP) (HWND hWnd);
	typedef VOID	(CALLBACK* LPMLZGETRESULT) (LPMLZ_GRT_RESULT lpResult);
	typedef VOID	(CALLBACK* LPMLZGETSAMPLINGPOSITION) (int nNumber, LPMLZ_GSP_PARAMETERS lpParameters);
	typedef DOUBLE	(CALLBACK* LPMLZDIFFERENTIATE) (LPMLZ_DIF_PARAMETERS lpParameters);
	typedef	int		(CALLBACK* LPMLZGETFILEVERSION) (	LPCWSTR lpszFileName, 
														DWORD* lpdwMajor, 
														DWORD* lpdwMinor, 
														DWORD* lpdwRevision,
														DWORD* lpdwBild );

	LPMLZINITIALIZE				mlzInitialize;
	LPMLZSTART					mlzStart;
	LPMLZSTOP					mlzStop;
	LPMLZGETRESULT				mlzGetResult;
	LPMLZGETSAMPLINGPOSITION	mlzGetSamplingPosition;
	LPMLZDIFFERENTIATE			mlzDifferentiate;
	LPMLZGETFILEVERSION			mlzGetFileVersion;

private:
	HMODULE m_hMLZ;
};