// TestLZDlg.cpp : t@C
//
#include "stdafx.h"
#include "afxwin.h"
#include "TestLZ.h"
#include "FormulaLZ.h"
#include "TestLZDlg.h"
#include <math.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();



// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
private:
	CStatic m_txtVersion;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_VERSION, m_txtVersion);
}

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO :  ɏǉĂ
#if _DEBUG
	LPCTSTR lpszFile[3] = { _T("TestLZ.exe"), _T("mgc4lz.dll"), _T("mfc140d.dll") };
#else
	LPCTSTR lpszFile[3] = { _T("TestLZ.exe"), _T("mgc4lz.dll"), _T("mfc140.dll") };
#endif

	DWORD	dwMajor[3] = { 0, 0, 0 };
	DWORD   dwMinor[3] = { 0, 0, 0 };
	DWORD   dwRevision[3] = { 0, 0, 0 };
	DWORD   dwBild[3] = { 0, 0, 0 };
	CString strVersion;
	CString strTmp;


	for(int nI = 0; nI < 3; nI++)
	{
		theApp.m_LZ.GetFileVersion(	lpszFile[nI], 
									&dwMajor[nI],
									&dwMinor[nI],
									&dwRevision[nI],
									&dwBild[nI]	);

		strTmp.Format(	_T("%s\tVersion : %d.%d.%d.%d\r"), 
						lpszFile[nI], 
						dwMajor[nI],
						dwMinor[nI],
						dwRevision[nI],
						dwBild[nI]	);

		strVersion += strTmp;
	}
	
	m_txtVersion.SetWindowText(strVersion);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestLZDlg _CAO


CTestLZDlg::CTestLZDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestLZDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_LZ.Set(MLZ_FALSE);
	
	m_nElapse[0] = MLZ_INI_TIMER_ELAPSE_8;
	m_nElapse[1] = MLZ_INI_TIMER_ELAPSE_7;
	m_nElapse[2] = MLZ_INI_TIMER_ELAPSE_6;
	m_nElapse[3] = MLZ_INI_TIMER_ELAPSE_5; 
	m_nElapse[4] = MLZ_INI_TIMER_ELAPSE_4;
	m_nElapse[5] = MLZ_INI_TIMER_ELAPSE_3; 
	m_nElapse[6] = MLZ_INI_TIMER_ELAPSE_2;
	m_nElapse[7] = MLZ_INI_TIMER_ELAPSE_1; 
	m_nElapse[8] = MLZ_INI_TIMER_ELAPSE_0;	
										
	m_nFactorial[0] = 0.0;
	m_nFactorial[1] = 1.0;
	m_nFactorial[2] = 2.0;
	m_nFactorial[3] = 6.0;
	m_nFactorial[4] = 24.0;
	m_nFactorial[5] = 120.0;
	m_nFactorial[6] = 720.0;
	m_nFactorial[7] = 5040.0;
	m_nFactorial[8] = 40320.0;
	m_nFactorial[9] = 362880.0;

	m_nPiTimes2 = 6.283185307;	// PI * 2
}

void CTestLZDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER1, m_sldTimerElapse);
	DDX_Control(pDX, IDC_STATIC_RESULT, m_txtResult);
	DDX_Control(pDX, IDC_CHECK1, m_chkExe);
	DDX_Control(pDX, IDC_CHECK2, m_chkZero);
	DDX_Control(pDX, IDC_CHECK3, m_chkStartingPoint);
	DDX_Control(pDX, IDC_RADIO0, m_radMode0);
	DDX_Control(pDX, IDC_RADIO1, m_radMode1);
	DDX_Control(pDX, IDC_RADIO2, m_radMode2);
	DDX_Control(pDX, IDC_RADIO3, m_radMode3);
	DDX_Control(pDX, IDC_TEXT_SLIDER_NUMBER, m_txtSliderNumber);
}

BEGIN_MESSAGE_MAP(CTestLZDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_TYPE_1A, OnType1a)
	ON_COMMAND(ID_TYPE_2A, OnType2a)
	ON_COMMAND(ID_TYPE_2E, OnType2e)
	ON_COMMAND(ID_TYPE_1C1, &CTestLZDlg::OnType1c1)
	ON_COMMAND(ID_TYPE_1C2, &CTestLZDlg::OnType1c2)
	ON_COMMAND(ID_TYPE_1C3, &CTestLZDlg::OnType1c3)
	ON_COMMAND(ID_TYPE_1D1, &CTestLZDlg::OnType1d1)
	ON_COMMAND(ID_TYPE_1D2, &CTestLZDlg::OnType1d2)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CTestLZDlg bZ[W nh

BOOL CTestLZDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
#if _DEBUG
	m_chkExe.SetCheck(BST_UNCHECKED);
#else
	m_chkExe.SetCheck(BST_CHECKED);
#endif
	m_radMode0.SetCheck(BST_CHECKED);

	m_mnuMain.LoadMenu(IDR_MAINFRAME);
	SetMenu(&m_mnuMain);
	m_hMenuDefault = m_mnuMain.GetSafeHmenu();

	m_lpLZ = &theApp.m_LZ;
	m_sldTimerElapse.SetWindowText(_T("J[\x\0"));
	m_sldTimerElapse.SetRange(0, MLZ_INI_TIMER_ELAPSE_COUNT - 1);
	m_sldTimerElapse.SetPos((MLZ_INI_TIMER_ELAPSE_COUNT - 1) / 2);

	TCHAR szDefault[8];
	wsprintf(szDefault, _T("%d"), MLZ_INI_TIMER_ELAPSE_DEFAULT);
	m_txtSliderNumber.SetWindowText(szDefault);

	m_DrawLine.Set(MLZ_NO);
	m_DrawPoint.Set(MLZ_NO);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

BOOL CTestLZDlg::DestroyWindow()
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	DestroyMenu(m_hMenuDefault);

	return CDialog::DestroyWindow();
}


void CTestLZDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) 
	{
		ShowAboutDlg();
	}
	else 
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTestLZDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);

	}
	else
	{
		CPaintDC			dc(this);
		MLZ_GSP_PARAMETERS	gspParameters;
		int					nDiameter = 8;
	
		
		if(m_DrawPoint.Get() == MLZ_YES)
		{
			// TvO_`
			m_lpLZ->mlzGetSamplingPosition(0, &gspParameters);

			if(gspParameters.nCount > 0)
			{
				dc.SelectObject(GetStockObject(BLACK_PEN));
				dc.SelectObject(GetStockObject(WHITE_BRUSH));
				
				for(int nI = 0; nI < gspParameters.nCount - 1; nI++) 
				{
					if(gspParameters.nChangingPosition == MLZ_YES)
						dc.SelectObject(GetStockObject(BLACK_BRUSH));
					
					dc.Ellipse(	gspParameters.ptSamplingPosition.x, 
								gspParameters.ptSamplingPosition.y,
								gspParameters.ptSamplingPosition.x + nDiameter, 
								gspParameters.ptSamplingPosition.y + nDiameter	);

					if(gspParameters.nChangingPosition)
						dc.SelectObject(GetStockObject(WHITE_BRUSH));

					m_lpLZ->mlzGetSamplingPosition(nI + 1, &gspParameters);	

					if(nI == 0)
						nDiameter = 4;
				}
			}

		}

		if(m_DrawLine.Get() == MLZ_YES) 
		{
			// TvO_萶`
			MLZ_GRT_RESULT grtResult;

			m_lpLZ->mlzGetResult(&grtResult);	// ͌

			if( (grtResult.nType & MLZ_GRT_TYPE_EQUATION) == MLZ_GRT_TYPE_CIRCLE )
				DrawCircle(&dc, &grtResult);
			else
				DrawLine(&dc, &grtResult);
		}

	}

	CDialog::OnPaint();
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTestLZDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestLZDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	CSliderCtrl* lpSlider = (CSliderCtrl*)pScrollBar;
	TCHAR		 szN[8];

	wsprintf(szN, _T("%d"), m_nElapse[lpSlider->GetPos()]);
	m_txtSliderNumber.SetWindowText(szN);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CTestLZDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B

	if(m_LZ.Get())
		return;

	// J[\̈ړ
	RECT rect;

	GetWindowRect(&rect); 

	rect.left	+= 10;
	rect.right	-= 420;
	rect.top	+= 90;
	rect.bottom -= 90;

	ClipCursor(&rect);

	//
	// ̃vOł́A}EX̍{^܂܃hbO邱ƂŃJ[\̍W
	// TvOB
	// J[\WTvOn߂܂ 
	int nPosition = m_sldTimerElapse.GetPos();
		
	// IZ DLL 
	MLZ_INI_PARAMETERS ip;

	ip.nTimerElapse = m_nElapse[nPosition];		// TvOg
#if _DEBUG
	ip.nFunction = MLZ_INI_FNC_STANDARD | MLZ_INI_FNC_OPT_DEBUG;
#else
	ip.nFunction = MLZ_INI_FNC_STANDARD;
#endif

	if(m_radMode1.GetCheck())
		ip.nFunction |= MLZ_INI_FNC_CMD_MODE_1;
	else if(m_radMode2.GetCheck())
		ip.nFunction |= MLZ_INI_FNC_CMD_MODE_2;
	else if(m_radMode3.GetCheck())
		ip.nFunction |= MLZ_INI_FNC_CMD_MODE_3;

	if(m_chkZero.GetCheck())
		ip.nFunction |= MLZ_INI_FNC_OPT_0TH;

	if(m_chkStartingPoint.GetCheck())
		ip.nFunction |= MLZ_INI_FNC_OPT_CIRCLE_A;


	m_lpLZ->mlzInitialize(&ip);	// ܂


	// TvOJn
	MLZ_STR_PARAMETERS	start;
	
	start.nErase	= FALSE;
	start.nLeft		= 10;
	start.nTop		= 30;
	start.nRight	= 570;
	start.nBottom	= 570;

	UINT nR = m_lpLZ->mlzStart(this->m_hWnd, &start);	
	//UINT nR = m_lpLZ->mlzStart(this->m_hWnd, NULL);	
	m_DrawLine.Set(MLZ_NO);	// 擾\ł
	m_DrawPoint.Set(MLZ_YES);	// 擾W\ł

	m_LZ.Set(MLZ_TRUE);

	InvalidateRect(NULL);
		
	CDialog::OnLButtonDown(nFlags, point);
}

void CTestLZDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	//
	//// J[\W̃TvOI܂
	//
	if(!m_LZ.Get())
		return;
	
	int nR = m_lpLZ->mlzStop(this->m_hWnd);	// TvOI

	ClipCursor(NULL);

	
	CString			strEquation, strFormat, strMessage;
	MLZ_GRT_RESULT	grtResult;

	SecureZeroMemory(&grtResult, sizeof(MLZ_GRT_RESULT));


	m_lpLZ->mlzGetResult(&grtResult);	// ͌

	if((grtResult.nType & MLZ_GRT_TYPE_EQUATION) == MLZ_GRT_TYPE_CIRCLE)
	{
		strFormat =	_T(" (+) x = %0.6f %+0.6f * cosA : y = %0.6f %+0.6f * sinA");
		grtResult.nCoefficient[3] = grtResult.nCoefficient[0]; 
		grtResult.nCoefficient[0] = grtResult.nCoefficient[2];	
	}
	else
	{
		strFormat = (grtResult.nRotated == MLZ_YES)? 
					  _T(" (+) x = %0.6fy^3 %+0.6fy^2 %+0.6fy^1 %+0.6fy^0")
					: _T(" (+) y = %0.6fx^3 %+0.6fx^2 %+0.6fx^1 %+0.6fx^0");
	}

	strEquation.Format(	strFormat,
						grtResult.nCoefficient[3],
						grtResult.nCoefficient[2],
						grtResult.nCoefficient[1],
						grtResult.nCoefficient[0]	);

	strMessage.Format(	_T("Number = %d : Changing point = %d : ")\
						_T("Sampling count = %d : Type = %04x : Error = %d %s"), 
						grtResult.nResultNo, 
						grtResult.nChangingCount, 
						grtResult.nSamplingCount, 
						grtResult.nType, 
						grtResult.nReturn,
						strEquation );

	m_txtResult.SetWindowText(strMessage);

	
	if(grtResult.nReturn == MLZ_SUCCESS && m_chkExe.GetCheck() == BST_CHECKED) 
	{
		// R}hs
		double nX;

		switch (grtResult.nType) 
		{
			case  MLZ_GRT_TYPE_1A :
				DifferentiateX(3.0);
				break;	
			case MLZ_GRT_TYPE_1B :
				break;
			case MLZ_GRT_TYPE_1C :
				// ̌XŎsR}hς
				if(grtResult.nCoefficient[1] > 0.000 && grtResult.nCoefficient[1] <= 0.578)
					nX = (grtResult.nRotated == MLZ_YES)? 75.0 : 15.0;
				else if(grtResult.nCoefficient[1] > 0.578 && grtResult.nCoefficient[1] < 1.732) 
					nX = 45.0;
				else
					nX = 75.0;
				
				DifferentiateX(nX);
				break;
			case MLZ_GRT_TYPE_1D :
				// ̌XŎsR}hς
				if(grtResult.nCoefficient[1] < 1.000) 
					nX = (grtResult.nRotated == MLZ_YES)? 65.0 : 20.0;
				else 
					nX = 65.0;
				
				DifferentiateX(nX);
				break;
			case MLZ_GRT_TYPE_2A :
				ShowAboutDlg();
				break;
			case MLZ_GRT_TYPE_2B :
				break;
			case MLZ_GRT_TYPE_2C :
				break;
			case MLZ_GRT_TYPE_2D :
				break;
			case MLZ_GRT_TYPE_2E :
				ShowFileDlg();
				break;
			case MLZ_GRT_TYPE_2F :
				break;
			case MLZ_GRT_TYPE_2G :
				break;
			case MLZ_GRT_TYPE_2H :
				break;
			case MLZ_GRT_TYPE_3A :
				break;
			case MLZ_GRT_TYPE_3B :
				break;
			case MLZ_GRT_TYPE_3C :
				break;
			case MLZ_GRT_TYPE_3D :
				break;
			case MLZ_GRT_TYPE_3E :
				break;
			case MLZ_GRT_TYPE_3F :
				break;
			case MLZ_GRT_TYPE_3G :
				break;
			case MLZ_GRT_TYPE_3H :
				break;

			case MLZ_GRT_TYPE_CIRCLE_R:		// E]
				break;
			case MLZ_GRT_TYPE_CIRCLE_R_T:	// E]An_
				break;
			case MLZ_GRT_TYPE_CIRCLE_R_B:	// E]An_
				break;
			case MLZ_GRT_TYPE_CIRCLE_L:		// ]
				break;
			case MLZ_GRT_TYPE_CIRCLE_L_T:	// ]An_
				break;
			case MLZ_GRT_TYPE_CIRCLE_L_B:	// ]An_
				break;

			case MLZ_GRT_TYPE_OTHER :
				break;
			default:	//MLZ_GRT_TYPE_ERROR
				break;
		}

	}

	// 擾W\ł
	INT nValue;

	nValue = (grtResult.nReturn == MLZ_SUCCESS && grtResult.nType != MLZ_GRT_TYPE_OTHER)? 
				MLZ_YES : MLZ_NO;
		
	m_DrawLine.Set(nValue);	
	
	InvalidateRect(NULL);

	m_LZ.Set(MLZ_FALSE);

	CDialog::OnLButtonUp(nFlags, point);
}

void CTestLZDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	m_DrawLine.Set(MLZ_NO);
	m_DrawPoint.Set(MLZ_NO);

	InvalidateRect(NULL);

	CDialog::OnRButtonDown(nFlags, point);
}

void CTestLZDlg::OnType1a()
{
	DifferentiateX(3.0);
}

void CTestLZDlg::OnType1c1()
{
	DifferentiateX(20.0);
}

void CTestLZDlg::OnType1c2()
{
	DifferentiateX(23.0);
}

void CTestLZDlg::OnType1c3()
{
	DifferentiateX(25.0);
}

void CTestLZDlg::OnType1d1()
{
	DifferentiateX(30.0);
}

void CTestLZDlg::OnType1d2()
{
	DifferentiateX(35.0);
}

void CTestLZDlg::OnType2a()
{
	ShowAboutDlg();
}

void CTestLZDlg::OnType2e()
{
	ShowFileDlg();
}


///////////////////////////////////////////////////////////////////////////////////////////////////
////
//// Private Functions
////
///////////////////////////////////////////////////////////////////////////////////////////////////
void CTestLZDlg::DrawCircle(CPaintDC* dc, LPMLZ_GRT_RESULT lpgrtResult)
{
	const double TWELVE_INTO_PI = 0.261799387;	// = PI/12
	//
	//// ~̕`
	//
	int	 nX, nY;
	double nAngle = 0.0;
	
	for(int nI = 0; nI < 25; nI++)
	{
		//nX = (int)(lpgrtResult->nCoefficient[0] + lpgrtResult->nCoefficient[2] * cos(nAngle));
		//nY = (int)(lpgrtResult->nCoefficient[1] + lpgrtResult->nCoefficient[2] * sin(nAngle));
		nX = (int)(lpgrtResult->nCoefficient[0] + lpgrtResult->nCoefficient[2] * Cosine(nAngle));
		nY = (int)(lpgrtResult->nCoefficient[1] + lpgrtResult->nCoefficient[2] * Sine(nAngle));

		if(nI == 0)
			dc->MoveTo(nX, nY);
		else 
			dc->LineTo(nX, nY);

		nAngle += TWELVE_INTO_PI;
	}
}

void CTestLZDlg::DrawLine(CPaintDC* dc, LPMLZ_GRT_RESULT lpgrtResult)
{
	//
	//// `
	//
	MLZ_GSP_PARAMETERS	gspParameters1, gspParameters2;
	int					nX, nY, n1, n2, n3, nTmp;

	
	m_lpLZ->mlzGetSamplingPosition(0, &gspParameters1);
	m_lpLZ->mlzGetSamplingPosition(gspParameters1.nCount - 1, &gspParameters2);

	// ]n͂wAxւKv
	if(lpgrtResult->nRotated == MLZ_YES) 
	{
		n1 = gspParameters1.ptSamplingPosition.y;
		n2 = gspParameters2.ptSamplingPosition.y;
	}
	else 
	{
		n1 = gspParameters1.ptSamplingPosition.x;
		n2 = gspParameters2.ptSamplingPosition.x;
	}


	if(n2 < n1) 
	{
		nTmp = n1;
		n1 = n2;
		n2 = nTmp;
	}

	n3 = (n2 - n1) / 20;

	if(n3 < 1)
		n3 = 1;

	for(nX = n1; nX < n2 + n3; nX+=n3) 
	{
		nY = (int)( lpgrtResult->nCoefficient[3] * nX * nX * nX + 
					lpgrtResult->nCoefficient[2] * nX * nX +
					lpgrtResult->nCoefficient[1] * nX +
					lpgrtResult->nCoefficient[0]	);

		if(lpgrtResult->nRotated == MLZ_YES) 
		{
			if(nX == n1)
				dc->MoveTo(nY, nX);
			else 
				dc->LineTo(nY, nX);
		}
		else 
		{
			if(nX == n1)
				dc->MoveTo(nX, nY);
			else 
				dc->LineTo(nX, nY);
		}
	}
 }

double CTestLZDlg::Sine(double nAngle)
{
	//
	//// sin A = A - A^3/3! + A^5/5! - A^7/7! + A^9/9! ......
	//
	double nN = -m_nPiTimes2 * (int)(nAngle / m_nPiTimes2 + 0.50) + nAngle;
		 
	return		nN
			-	nN * nN * nN / m_nFactorial[3]
			+	nN * nN * nN * nN * nN / m_nFactorial[5]
			-	nN * nN * nN * nN * nN * nN * nN / m_nFactorial[7];
}

double CTestLZDlg::Cosine(double nAngle)
{
	//
	//// cos A = 1 - A^2/2! + A^4/4! - A^6/6! + A^8/8! ......
	//
	double nN = -m_nPiTimes2 * (int)(nAngle / m_nPiTimes2 + 0.50) + nAngle;
	
	return		m_nFactorial[1] 
			-	nN * nN / m_nFactorial[2]
			+	nN * nN * nN * nN / m_nFactorial[4]
			-	nN * nN * nN * nN * nN * nN / m_nFactorial[6]
			+	nN * nN * nN * nN * nN * nN * nN * nN / m_nFactorial[8];
}

void CTestLZDlg::DifferentiateX(double nX)
{
	//
	//  y = 3x^2 + 4x + 5  MLZ_DIF_PARAMETERS.nX ɂl MLZ_DIF_PARAMETERS.nZ _
	//  ŋ߂
	//  MLZ_DIF_PARAMETERS.nZ  2,3,5,7,9,11 g
	//  vZ(y=3x^2+4x+5)̓R[obN֐ŏ
	//  MLZ_DIF_PARAMETERS.lpParameters ̓R[obN֐(MLZ_DIF_PARAMETERS.lpFormulaLZ)
	//  ̂܂ܓn
	//
	MLZ_DIF_PARAMETERS	dp;
	double				nResult = 0;

	dp.lpFormulaLZ = *FormulaLZ;
	dp.nX		   = nX;
	dp.nZ		   = 11;
	dp.nH		   = 0.5;
	dp.lpParameters = NULL;
	
	nResult = m_lpLZ->mlzDifferentiate(&dp);

	CString str;

	str.Format(	_T("y=3x^2+4x+5  x=%.1f ɂ %d _\n\rResult: %.8f\n"),
				dp.nX,
				dp.nZ, 
				nResult );

	AfxMessageBox(str.GetBuffer(), MB_OK | MB_ICONINFORMATION);
}

void CTestLZDlg::ShowAboutDlg()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CTestLZDlg::ShowFileDlg()
{
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST, NULL, this);
	fileDlg.DoModal();
}
