// TestLZDlg.h : wb_[ t@C
//
#pragma once

#include "m4lz.h"
#include "afxcmn.h"
#include "afxwin.h"

// CTestLZDlg _CAO
class CTestLZDlg : public CDialog
{
// RXgNV
public:

	CTestLZDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_TESTLZ_DIALOG };

	protected: 
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g

// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	virtual BOOL DestroyWindow();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

	afx_msg void OnType1a();
	afx_msg void OnType1c1();
	afx_msg void OnType1c2();
	afx_msg void OnType1c3();
	afx_msg void OnType1d1();
	afx_msg void OnType1d2();
	afx_msg void OnType2a();
	afx_msg void OnType2e();

private:
	int m_nElapse[MLZ_INI_TIMER_ELAPSE_COUNT];

	typedef struct 
	{
		int  nDrawLine;
		void Set(int nValue) { nDrawLine = nValue; }
		int  Get() { return nDrawLine; }
		//__declspec(property(get = Get, put = Set)) int DrawLine;
	} DRAW_LINE;

	typedef struct 
	{
		int  nDrawPoint;
		void Set(int nValue) { nDrawPoint = nValue; };
		int  Get() { return nDrawPoint; };
	} DRAW_POINT;

	typedef struct 
	{
		BOOL  bLZ;
		void Set(int nValue) { bLZ = nValue; };
		int  Get() { return bLZ; };
	} LZ;


	double m_nFactorial[10];
	double m_nPiTimes2;
	
	DRAW_LINE	m_DrawLine;
	DRAW_POINT	m_DrawPoint;
	LZ			m_LZ;
	
	CM4lz*		m_lpLZ; 
	CSliderCtrl m_sldTimerElapse;
	CStatic		m_txtResult;
	CStatic		m_txtSliderNumber;
	CMenu		m_mnuMain;
	CButton		m_chkExe;
	CButton		m_chkZero;
	CButton		m_chkStartingPoint;
	CButton		m_radMode0;
	CButton		m_radMode1;
	CButton		m_radMode2;
	CButton		m_radMode3;

	HMENU	m_hMenuDefault;
	
	void DifferentiateX(double nX);
	void ShowAboutDlg();
	void ShowFileDlg();
	void DrawLine(CPaintDC* dc, LPMLZ_GRT_RESULT lpgrtResult);
	void DrawCircle(CPaintDC* dc, LPMLZ_GRT_RESULT lpgrtResult);
	double Sine(double nAngle);
	double Cosine(double nAngle);
	
};
