Imports System.Runtime.InteropServices

Module m4lz
    '///
    '//// mgc4lz.dll  Header Ver4.1600a
    '//
    '///  (C) m.magic & K Maruyama. All rights reserved.
    '////

    '//
    '//// common
    '//
    Structure MLZ_POINT
        Dim x As Integer
        Dim y As Integer
    End Structure

    Public Const MLZ_TRUE As Integer = 1
    Public Const MLZ_FALSE As Integer = 0
    Public Const MLZ_NULL As Integer = 0
    Public Const MLZ_YES As Integer = MLZ_TRUE
    Public Const MLZ_NO As Integer = MLZ_FALSE

    Public Const MLZ_SUCCESS As Integer = 0
    Public Const MLZ_FAILURE As Integer = -1

    '//
    '//// mlzInitialize
    '//
    Structure MLZ_INI_PARAMETERS
        Dim timerElapse As Integer    '// J[\ʒu̎擾Ԋu
        Dim functions As Integer
    End Structure

    '/// 
    Public Const MLZ_INI_TIMER_ELAPSE_COUNT As Integer = 9
    Public Const MLZ_INI_TIMER_ELAPSE_0 As Integer = 3
    Public Const MLZ_INI_TIMER_ELAPSE_1 As Integer = 4
    Public Const MLZ_INI_TIMER_ELAPSE_2 As Integer = 6
    Public Const MLZ_INI_TIMER_ELAPSE_3 As Integer = 8
    Public Const MLZ_INI_TIMER_ELAPSE_4 As Integer = 11
    Public Const MLZ_INI_TIMER_ELAPSE_5 As Integer = 16
    Public Const MLZ_INI_TIMER_ELAPSE_6 As Integer = 22
    Public Const MLZ_INI_TIMER_ELAPSE_7 As Integer = 32
    Public Const MLZ_INI_TIMER_ELAPSE_8 As Integer = 44
    Public Const MLZ_INI_TIMER_ELAPSE_DEFAULT As Integer = MLZ_INI_TIMER_ELAPSE_4
    Public Const MLZ_INI_TIMER_ELAPSE_MAX As Integer = 64
    Public Const MLZ_INI_TIMER_ELAPSE_MIN As Integer = 1

    Public Const MLZ_INI_FNC_COMMANDS As Integer = &HFF
    Public Const MLZ_INI_FNC_CMD_MODE_0 As Integer = &H0
    Public Const MLZ_INI_FNC_CMD_MODE_1 As Integer = &H1
    Public Const MLZ_INI_FNC_CMD_MODE_2 As Integer = &H2
    Public Const MLZ_INI_FNC_CMD_MODE_3 As Integer = &H3

    Public Const MLZ_INI_FNC_OPTIONS As Integer = &HFFFFFF00
    Public Const MLZ_INI_FNC_OPT_0TH As Integer = &H100 '// O
    Public Const MLZ_INI_FNC_OPT_CIRCLE_A As Integer = &H8000   '// ~̎nʒu𔻒肷
    Public Const MLZ_INI_FNC_OPT_REDRAW As Integer = &H8000000  '// TvO_`
    Public Const MLZ_INI_FNC_OPT_DEBUG_FILE As Integer = &H80000000

    Public Const MLZ_INI_FNC_DEFAULT As Integer = MLZ_INI_FNC_CMD_MODE_0
    Public Const MLZ_INI_FNC_STANDARD As Integer = MLZ_INI_FNC_CMD_MODE_0 Or MLZ_INI_FNC_OPT_REDRAW


    '//
    '//// mlzDifferentiate
    '//
    Public Delegate Function FormulaLZ(ByVal Xi As Double, ByVal parameters As Integer) As Double

    Structure MLZ_DIF_PARAMETERS
        Dim x As Double               '// x ɂl߂
        Dim z As Integer              '// ̓_
        Dim h As Double               '// x ̑
        Dim formulaLZ As FormulaLZ    '// vZ邽߂̃R[obN֐
        Dim parameters As Integer     '// Cӂ̃|C^
    End Structure

    '/// 
    Public Const MLZ_DIF_Z_2 As Integer = 2
    Public Const MLZ_DIF_Z_3 As Integer = 3
    Public Const MLZ_DIF_Z_5 As Integer = 5
    Public Const MLZ_DIF_Z_7 As Integer = 7
    Public Const MLZ_DIF_Z_9 As Integer = 9
    Public Const MLZ_DIF_Z_11 As Integer = 11

    '//
    '//// mlzStart
    '//
    Structure MLZ_STR_PARAMETERS
        Dim bottom As Integer  '// ĕ`̈ 
        Dim left As Integer
        Dim right As Integer
        Dim top As Integer
        Dim _erase As Integer   '// wi邩ǂ
    End Structure

    '//
    '//// mlzStop
    '//

    '/// ߂l
    Public Const MLZ_STP_ERR_UNDER_EXECUTION As Integer = 500       '// 
    Public Const MLZ_STP_ERR_KILLED_TIMER As Integer = -500         '// ^C}[sS
    Public Const MLZ_STP_ERR_BUFFER_OVERFLOW As Integer = -501      '// TvOpobt@s
    Public Const MLZ_STP_ERR_TIME_OUT As Integer = -502             '// Ԑ؂
    Public Const MLZ_STP_ERR_FEW_SAMPLINGS As Integer = -503        '// TvOs
    Public Const MLZ_STP_ERR_CHANGEING_POSITION As Integer = -504   '// ϋɓ_ʒu
    Public Const MLZ_STP_ERR_POSITION As Integer = -505             '// n_I_ω_̈ʒu
    Public Const MLZ_STP_ERR_DISTANCE As Integer = -580             '// TvO_ƍœK̒l̋傫
    Public Const MLZ_STP_ERR_CANNOT_ANALYZE As Integer = -1001      '// ͕s\

    '//
    '//// mlzGetResult
    '//

    '// nReturn
    Public Const MLZ_GRT_RTN_UNDER_EXECUTION As Integer = MLZ_STP_ERR_UNDER_EXECUTION       '// 
    Public Const MLZ_GRT_RTN_KILLED_TIMER As Integer = MLZ_STP_ERR_KILLED_TIMER             '// ^C}[sS
    Public Const MLZ_GRT_RTN_BUFFER_OVERFLOW As Integer = MLZ_STP_ERR_BUFFER_OVERFLOW       '// TvOpobt@s
    Public Const MLZ_GRT_RTN_TIME_OUT As Integer = MLZ_STP_ERR_TIME_OUT                     '// Ԑ؂
    Public Const MLZ_GRT_RTN_FEW_SAMPLINGS As Integer = MLZ_STP_ERR_FEW_SAMPLINGS           '// TvOs
    Public Const MLZ_GRT_RTN_CHANGEING_POSITION As Integer = MLZ_STP_ERR_CHANGEING_POSITION '// ϋɓ_ʒu
    Public Const MLZ_GRT_RTN_POSITION As Integer = MLZ_STP_ERR_POSITION                     '// n_I_ω_̈ʒu
    Public Const MLZ_GRT_RTN_DISTANCE As Integer = MLZ_STP_ERR_DISTANCE                     '// TvO_ƍœK̒l̋傫
    Public Const MLZ_GRT_RTN_CANNOT_ANALYZE As Integer = MLZ_STP_ERR_CANNOT_ANALYZE         '// ͕s\

    '// nType
    Public Const MLZ_GRT_TYPE_EQUATION As Integer = &HFF
    Public Const MLZ_GRT_TYPE_0TH As Integer = &H0
    Public Const MLZ_GRT_TYPE_1TH As Integer = &H1
    Public Const MLZ_GRT_TYPE_2TH As Integer = &H2
    Public Const MLZ_GRT_TYPE_3TH As Integer = &H3
    Public Const MLZ_GRT_TYPE_CIRCLE As Integer = &H80

    Public Const MLZ_GRT_TYPE_DIVISION As Integer = &HF000
    Public Const MLZ_GRT_TYPE_DIVISION_1 As Integer = &H1000
    Public Const MLZ_GRT_TYPE_DIVISION_2 As Integer = &H2000
    Public Const MLZ_GRT_TYPE_DIVISION_3 As Integer = &H3000

    Public Const MLZ_GRT_TYPE_1A As Integer = &H1
    Public Const MLZ_GRT_TYPE_1B As Integer = &H101
    Public Const MLZ_GRT_TYPE_1C As Integer = &H201
    Public Const MLZ_GRT_TYPE_1D As Integer = &H301
    Public Const MLZ_GRT_TYPE_2A As Integer = &H2
    Public Const MLZ_GRT_TYPE_2B As Integer = &H102
    Public Const MLZ_GRT_TYPE_2C As Integer = &H202
    Public Const MLZ_GRT_TYPE_2D As Integer = &H302
    Public Const MLZ_GRT_TYPE_2E As Integer = &H402
    Public Const MLZ_GRT_TYPE_2F As Integer = &H502
    Public Const MLZ_GRT_TYPE_2G As Integer = &H602
    Public Const MLZ_GRT_TYPE_2H As Integer = &H702

    Public Const MLZ_GRT_TYPE_3A As Integer = &H3
    Public Const MLZ_GRT_TYPE_3B As Integer = &H103
    Public Const MLZ_GRT_TYPE_3C As Integer = &H203
    Public Const MLZ_GRT_TYPE_3D As Integer = &H303
    Public Const MLZ_GRT_TYPE_3E As Integer = &H403
    Public Const MLZ_GRT_TYPE_3F As Integer = &H503
    Public Const MLZ_GRT_TYPE_3G As Integer = &H603
    Public Const MLZ_GRT_TYPE_3H As Integer = &H703

    Public Const MLZ_GRT_TYPE_CIRCLE_R As Integer = &H80           '// E]
    Public Const MLZ_GRT_TYPE_CIRCLE_R0 As Integer = MLZ_GRT_TYPE_CIRCLE_R  '// E]
    Public Const MLZ_GRT_TYPE_CIRCLE_RU As Integer = &H1080         '// E]An_
    Public Const MLZ_GRT_TYPE_CIRCLE_RB As Integer = &H2080         '// E]An_
    Public Const MLZ_GRT_TYPE_CIRCLE_L As Integer = &H480          '// ]
    Public Const MLZ_GRT_TYPE_CIRCLE_L0 As Integer = MLZ_GRT_TYPE_CIRCLE_L  '// ]
    Public Const MLZ_GRT_TYPE_CIRCLE_LU As Integer = &H1480         '// ]An_
    Public Const MLZ_GRT_TYPE_CIRCLE_LB As Integer = &H2480         '// ]An_


    Public Const MLZ_GRT_TYPE_OTHER As Integer = &HFF       '//	255
    Public Const MLZ_GRT_TYPE_ERROR As Integer = &HFFFFFFFF '//	-1

    Structure MLZ_GRT_RESULT
        Dim resultNo As Integer        '// s
        Dim result As Integer          '// s
        Dim type As Integer            '// J[\OՂ̎
        Dim changingCount As Integer   '// ω_
        Dim samplingCount As Integer   '// J[\W̕W{
        Dim rotated As Integer         '// W]ǂ
        <VBFixedArray(7), MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> _
           Dim coefficient() As Double    '// W
        Public Sub initialize()
            ReDim coefficient(7)
        End Sub
    End Structure

    '//
    '//// mlzGetSamplingPosition
    '//
    Structure MLZ_GSP_PARAMETERS
        Dim resultNo As Integer            '// s
        Dim count As Integer               '// ݂̕W{
        Dim changingPosition As Integer    '// W{ω_ǂ
        Dim samplingPosition As MLZ_POINT  '// W{W
        Public Sub initialize()
            resultNo = count = changingPosition = 0
            samplingPosition.x = samplingPosition.y = 0
        End Sub
    End Structure


    Public Declare Function mlzInitialize Lib "mgc4lz.dll" (ByRef parameters As MLZ_INI_PARAMETERS) As Integer
    Public Declare Function mlzStart Lib "mgc4lz.dll" (ByVal hWnd As IntPtr, ByRef parameters As MLZ_STR_PARAMETERS) As Integer
    Public Declare Function mlzStart Lib "mgc4lz.dll" (ByVal hWnd As IntPtr, ByRef parameters As Integer) As Integer
    Public Declare Function mlzStop Lib "mgc4lz.dll" (ByVal hWnd As IntPtr) As Integer
    Public Declare Function mlzGetResult Lib "mgc4lz.dll" (ByRef result As MLZ_GRT_RESULT) As IntPtr
    Public Declare Function mlzGetSamplingPosition Lib "mgc4lz.dll" (ByVal n As Integer, ByRef parameters As MLZ_GSP_PARAMETERS) As IntPtr
    Public Declare Function mlzDifferentiate Lib "mgc4lz.dll" (ByRef parameters As MLZ_DIF_PARAMETERS) As Double
    Public Declare Unicode Function mlzGetFileVersion Lib "mgc4lz.dll" (ByVal file As String, ByRef major As Integer, ByRef minor As Integer, ByRef revision As Integer, ByRef bild As Integer) As Integer

End Module
